<?php
/**
 * Offers helper functions for language issues
 */
class d2u_machinery_lang_helper extends \D2U_Helper\ALangHelper {
	/**
	 * @var string[] Array with englisch replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_english = [
		'd2u_machinery_advantages' => 'Benefits at a glance',
		'd2u_machinery_alternative_machines' => 'Alternative Machines',
		'd2u_machinery_back_machine_list' => 'Go back to machine list',
		'd2u_machinery_consultation_heading' => 'Let us advise you',
		'd2u_machinery_consultation_hint' => 'Together we will find the best solution for you.<br><b>Please contact us.</b>',
		'd2u_machinery_consultation_link_machine' => 'Go to inquiry form',
		'd2u_machinery_consultation_link_personal' => 'For personal consultancy',
		'd2u_machinery_consultation_text' => 'We will help you to find the right product.',
		'd2u_machinery_dimensions_length' => 'Length',
		'd2u_machinery_dimensions_length_width_height' => 'Dimensions (L&nbsp;x&nbsp;W&nbsp;x&nbsp;H)',
		'd2u_machinery_dimensions_width_height_depth' => 'Dimensions (W&nbsp;x&nbsp;H&nbsp;x&nbsp;D)',
		'd2u_machinery_downloads' => 'Downloads',
		'd2u_machinery_engine_power' => 'Drive performance',
		'd2u_machinery_engine_power_frequency_controlled' => 'frequency controlled',
		'd2u_machinery_form_address' => 'Address',
		'd2u_machinery_form_city' => 'City',
		'd2u_machinery_form_company' => 'Company',
		'd2u_machinery_form_country' => 'Country',
		'd2u_machinery_form_email' => 'E-mail ',
		'd2u_machinery_form_fax' => 'Fax',
		'd2u_machinery_form_message' => 'Comment',
		'd2u_machinery_form_name' => 'Last name',
		'd2u_machinery_form_phone' => 'Phone',
		'd2u_machinery_form_please_call' => 'Please call back',
		'd2u_machinery_form_position' => 'function',
		'd2u_machinery_form_privacy_policy' => 'I consent to the storage and processing of my contact and usage data by the owner of the website. I\'ve learned about the scope of data processing <a href="+++LINK_PRIVACY_POLICY+++" target="_blank">here</a>. I have the right to object to such use at any time under the contact details provided in the <a href="+++LINK_IMPRESS+++" target="_blank">imprint</a>.',
		'd2u_machinery_form_required' => 'Required',
		'd2u_machinery_form_send' => 'Send',
		'd2u_machinery_form_thanks' => 'Thank you for your message. Your request will be processed as quickly as possible.',
		'd2u_machinery_form_validate_address' => 'Please enter your address.',
		'd2u_machinery_form_validate_city' => 'Please enter your city.',
		'd2u_machinery_form_validate_company' => 'Please enter the company name.',
		'd2u_machinery_form_validate_country' => 'Please enter your country.',
		'd2u_machinery_form_validate_email' => 'Please enter an email address.',
		'd2u_machinery_form_validate_name' => 'Please enter your last name.',
		'd2u_machinery_form_validate_phone' => 'Please enter your phone number.',
		'd2u_machinery_form_validate_privacy_policy' => 'It\'s necessary to accept the privacy policy.',
		'd2u_machinery_form_validate_spam_detected' => 'Your message was classified as spam, because not visible fields were filled in.',
		'd2u_machinery_form_validate_spambots' => 'Spam protection: please take at least 10 seconds to fill out the form.',
		'd2u_machinery_form_validate_title' => 'Please check',
		'd2u_machinery_form_validate_zip' => 'Please enter your zip code.',
		'd2u_machinery_form_vorname' => 'First name',
		'd2u_machinery_form_zip' => 'Postal Code',
		'd2u_machinery_no_machines' => 'We are sorry. Currently we have no machines available. Please try again later.',
		'd2u_machinery_operating_voltage' => 'Operating voltage',
		'd2u_machinery_our_products' => 'Machines for Your Applications',
		'd2u_machinery_overview' => 'Machine',
		'd2u_machinery_pics' => 'Pictures',
		'd2u_machinery_productfinder_heading' => 'Product Finder',
		'd2u_machinery_productfinder_text' => 'Find your product',
		'd2u_machinery_references' => 'Credentials',
		'd2u_machinery_request' => 'Inquiry',
		'd2u_machinery_service' => 'Service details',
		'd2u_machinery_software' => 'Software',
		'd2u_machinery_tech_data' => 'Technical&nbsp;Data',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_ca' => 'approx.',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_degrees' => 'Degrees',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'Pieces',
		'd2u_machinery_unit_rotations_min' => 'r/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Usage areas',
		'd2u_machinery_video' => 'Video',
		'd2u_machinery_weight' => 'Weight'
	];

	/**
	 * @var string[] Array with german replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_german = [
		'd2u_machinery_advantages' => 'Vorteile auf einen Blick',
		'd2u_machinery_alternative_machines' => 'Alternative Maschinen',
		'd2u_machinery_back_machine_list' => 'Zurück zur Maschinenliste',
		'd2u_machinery_consultation_heading' => 'Lassen Sie sich beraten',
		'd2u_machinery_consultation_hint' => 'Wir bieten für Ihren Bedarf die optimale Lösung.<br><b>Nehmen Sie Kontakt mit uns auf.</b>',
		'd2u_machinery_consultation_link_machine' => 'Zur Maschinenanfrage',
		'd2u_machinery_consultation_link_personal' => 'Zur persönlichen Beratung',
		'd2u_machinery_consultation_text' => 'Wir helfen Ihnen dabei, das passende<br>Produkt zu finden.',
		'd2u_machinery_dimensions_length' => 'Länge',
		'd2u_machinery_dimensions_length_width_height' => 'Maße (L&nbsp;x&nbsp;B&nbsp;x&nbsp;H)',
		'd2u_machinery_dimensions_width_height_depth' => 'Maße (B&nbsp;x&nbsp;H&nbsp;x&nbsp;T)',
		'd2u_machinery_downloads' => 'Downloads',
		'd2u_machinery_engine_power' => 'Motorleistung',
		'd2u_machinery_engine_power_frequency_controlled' => 'frequenzgeregelt',
		'd2u_machinery_form_address' => 'Straße/Nr.',
		'd2u_machinery_form_city' => 'Ort',
		'd2u_machinery_form_company' => 'Firma',
		'd2u_machinery_form_country' => 'Land',
		'd2u_machinery_form_email' => 'E-Mail Adresse',
		'd2u_machinery_form_fax' => 'Fax',
		'd2u_machinery_form_message' => 'Bemerkung',
		'd2u_machinery_form_name' => 'Name',
		'd2u_machinery_form_phone' => 'Telefon',
		'd2u_machinery_form_please_call' => 'Bitte um Rückruf',
		'd2u_machinery_form_position' => 'Funktion',
		'd2u_machinery_form_privacy_policy' => 'Ich willige in die Speicherung und Verarbeitung meiner Kontakt- und Nutzungsdaten durch den Betreiber der Webseite ein. Über den Umfang der Datenverarbeitung habe ich mich  <a href="+++LINK_PRIVACY_POLICY+++" target="_blank">hier</a> informiert. Ich habe das Recht dieser Verwendung jederzeit unter den im <a href="+++LINK_IMPRESS+++" target="_blank">Impressum</a> angegebenen Kontaktdaten zu widersprechen.',
		'd2u_machinery_form_required' => 'Pflichtfelder',
		'd2u_machinery_form_send' => 'Abschicken',
		'd2u_machinery_form_thanks' => 'Vielen Dank für Ihre Nachricht. Ihre Anfrage wird schnellstmöglich bearbeitet.',
		'd2u_machinery_form_validate_address' => 'Bitte geben Sie Ihre Anschrift ein.',
		'd2u_machinery_form_validate_city' => 'Bitte geben Sie Ihren Ort ein.',
		'd2u_machinery_form_validate_company' => 'Bitte geben Sie den Firmennamen an',
		'd2u_machinery_form_validate_country' => 'Bitte geben Sie Ihr Land ein.',
		'd2u_machinery_form_validate_email' => 'Bitte geben Sie eine Emailadresse an.',
		'd2u_machinery_form_validate_name' => 'Bitte geben Sie Ihren Nachnamen an.',
		'd2u_machinery_form_validate_phone' => 'Bitte geben Sie Ihre Telefonnummer ein.',
		'd2u_machinery_form_validate_privacy_policy' => 'Der Datenschutzerklärung muss zugestimmt werden.',
		'd2u_machinery_form_validate_spam_detected' => 'hr Eintrag wurde als Spam eingestuft, da nicht sichtbare Felder ausgefüllt wurden.',
		'd2u_machinery_form_validate_spambots' => 'Spamschutz: bitte lassen Sie sich mindestens 10 Sekunden Zeit um dieses Formular auszufüllen.',
		'd2u_machinery_form_validate_title' => 'Bitte überprüfen Sie Ihre Angaben und korrigieren Sie diese gegebenenfalls.',
		'd2u_machinery_form_validate_zip' => 'Bitte geben Sie Ihre PLZ ein.',
		'd2u_machinery_form_vorname' => 'Vorname',
		'd2u_machinery_form_zip' => 'PLZ',
		'd2u_machinery_no_machines' => 'Es tut uns Leid. Im Moment haben wir keine Angebote verfügbar. Bitte versuchen Sie es später nocheinmal.',
		'd2u_machinery_operating_voltage' => 'Betriebsspannung',
		'd2u_machinery_our_products' => 'Maschinen für Ihren Einsatz',
		'd2u_machinery_overview' => 'Maschine',
		'd2u_machinery_pics' => 'Bilder',
		'd2u_machinery_productfinder_heading' => 'Produktfinder',
		'd2u_machinery_productfinder_text' => 'Finden Sie genau Ihr Produkt',
		'd2u_machinery_references' => 'Kundenerfahrungen',
		'd2u_machinery_request' => 'Anfrage',
		'd2u_machinery_service' => 'Service&nbsp;Details',
		'd2u_machinery_software' => 'Software',
		'd2u_machinery_tech_data' => 'Technische Daten',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_ca' => 'ca.',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'Stück',
		'd2u_machinery_unit_rotations_min' => 'U/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Anwendungsgebiete',
		'd2u_machinery_video' => 'Video',
		'd2u_machinery_weight' => 'Gewicht'
	];

	/**
	 * @var string[] Array with french replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_french = [
		'd2u_machinery_advantages' => 'Les avantages en un coup d\'œil',
		'd2u_machinery_alternative_machines' => 'Machines alternatives',
		'd2u_machinery_back_machine_list' => 'Retour à la liste des machines',
		'd2u_machinery_consultation_heading' => 'Laissez vous conseiller',
		'd2u_machinery_consultation_hint' => 'Nous fournissons la solution optimale à vos besoins.<br><b>Contactez-nous.</b>',
		'd2u_machinery_consultation_link_machine' => 'Vers demande machine',
		'd2u_machinery_consultation_link_personal' => 'Pour un conseil personnalisé ',
		'd2u_machinery_consultation_text' => 'Nous vous aidons à trouver le bon <br> produit.',
		'd2u_machinery_dimensions_length' => 'Longueur',
		'd2u_machinery_dimensions_length_width_height' => 'Dimensions (L&nbsp;x&nbsp;L&nbsp;x&nbsp;H)',
		'd2u_machinery_dimensions_width_height_depth' => 'Dimensions  (L&nbsp;x&nbsp;H&nbsp;x&nbsp;P) ',
		'd2u_machinery_downloads' => 'Téléchargements',
		'd2u_machinery_engine_power' => 'Puissance moteur',
		'd2u_machinery_engine_power_frequency_controlled' => 'fréquence commandée',
		'd2u_machinery_form_address' => 'Adresse',
		'd2u_machinery_form_city' => 'Ville',
		'd2u_machinery_form_company' => 'Société',
		'd2u_machinery_form_country' => 'Pays',
		'd2u_machinery_form_email' => 'E-Mail',
		'd2u_machinery_form_fax' => 'Télécopie',
		'd2u_machinery_form_message' => 'Remarques',
		'd2u_machinery_form_name' => 'Nom',
		'd2u_machinery_form_phone' => 'Téléphone',
		'd2u_machinery_form_please_call' => 'Demande de rappel',
		'd2u_machinery_form_position' => 'Fonction',
		'd2u_machinery_form_privacy_policy' => 'Je consens au stockage et au traitement de mes données de contact et d\'utilisation par l\'exploitant du site. J\'ai découvert l\'étendue du traitement des données <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> ici </a>. J\'ai le droit de m\'opposer à cette utilisation à tout moment en utilisant les coordonnées fournies dans l\'<a href="+++LINK_IMPRESS+++" target="_blank"> empreinte </a>.',
		'd2u_machinery_form_required' => 'Requis',
		'd2u_machinery_form_send' => 'Envoyer',
		'd2u_machinery_form_thanks' => 'Nous vous remercions pour votre demande. Elle sera traitée dans les meilleurs délais.',
		'd2u_machinery_form_validate_address' => 'Veuillez indiquer votre adresse.',
		'd2u_machinery_form_validate_city' => 'Veuillez indiquer votre ville.',
		'd2u_machinery_form_validate_company' => 'Veuillez indiquer votre société',
		'd2u_machinery_form_validate_country' => 'Veuillez indiquer votre pays.',
		'd2u_machinery_form_validate_email' => 'Veuillez indiquer votre adresse email.',
		'd2u_machinery_form_validate_name' => 'Veuillez indiquer votre nom',
		'd2u_machinery_form_validate_phone' => 'Veuillez indiquer votre numéro de téléphone.',
		'd2u_machinery_form_validate_privacy_policy' => 'La politique de confidentialité doit être approuvée.',
		'd2u_machinery_form_validate_spam_detected' => 'Votre message a été classé comme spam, car des champs non visibles ont été remplis.',
		'd2u_machinery_form_validate_spambots' => 'Protection anti-spam: veuillez prendre au moins 10 secondes pour remplir le formulaire.',
		'd2u_machinery_form_validate_title' => 'Veuillez vérifier les données et, le cas échéant, les corriger.',
		'd2u_machinery_form_validate_zip' => 'Veuillez indiquer votre code postal.',
		'd2u_machinery_form_vorname' => 'Prénom',
		'd2u_machinery_form_zip' => 'Code postal',
		'd2u_machinery_no_machines' => 'Nous sommes désolés. Pour le moment, nous n\'avons aucune offre disponible. Veuillez réessayer plus tard.',
		'd2u_machinery_operating_voltage' => 'tension de fonctionnement',
		'd2u_machinery_our_products' => 'Nos machines',
		'd2u_machinery_overview' => 'Machine',
		'd2u_machinery_pics' => 'Photos',
		'd2u_machinery_productfinder_heading' => 'Recherche de produits',
		'd2u_machinery_productfinder_text' => 'Trouvez exactement votre produit',
		'd2u_machinery_references' => 'Références ',
		'd2u_machinery_request' => 'Demande',
		'd2u_machinery_service' => 'Détails du service',
		'd2u_machinery_software' => 'Logiciel',
		'd2u_machinery_tech_data' => 'Données techniques',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_ca' => 'approx.',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'Pièce',
		'd2u_machinery_unit_rotations_min' => 'r/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Procédés',
		'd2u_machinery_video' => 'Vidéo',
		'd2u_machinery_weight' => 'Poids'
	];

	/**
	 * @var string[] Array with spanish replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_spanish = [
		'd2u_machinery_advantages' => 'Ventajas de un vistazo',
		'd2u_machinery_alternative_machines' => 'Máquinas alternativas',
		'd2u_machinery_back_machine_list' => 'Volver a la lista de máquinas',
		'd2u_machinery_consultation_heading' => 'Déjese asesorar',
		'd2u_machinery_consultation_hint' => 'Brindamos la solución óptima para sus necesidades.<br><b>Contáctenos.</b>',
		'd2u_machinery_consultation_link_machine' => 'Ir a formulario de consulta.',
		'd2u_machinery_consultation_link_personal' => 'Para la consultora personal.',
		'd2u_machinery_consultation_text' => 'Le ayudamos a encontrar la empresa<br> producto adecuado.',
		'd2u_machinery_dimensions_length' => 'Longitud',
		'd2u_machinery_dimensions_length_width_height' => 'Dimensiones (L&nbsp;x&nbsp;An&nbsp;x&nbsp;Al)',
		'd2u_machinery_dimensions_width_height_depth' => 'Dimensiones (An&nbsp;x&nbsp;Al&nbsp;x&nbsp;P)',
		'd2u_machinery_downloads' => 'Descargas',
		'd2u_machinery_engine_power' => 'Potencia del motor',
		'd2u_machinery_engine_power_frequency_controlled' => 'Controlada por frecuencia',
		'd2u_machinery_form_address' => 'Dirección',
		'd2u_machinery_form_city' => 'Localidad',
		'd2u_machinery_form_company' => 'Empresa',
		'd2u_machinery_form_country' => 'País',
		'd2u_machinery_form_email' => 'E-mail',
		'd2u_machinery_form_fax' => 'Fax',
		'd2u_machinery_form_message' => 'Observación',
		'd2u_machinery_form_name' => 'Apellido',
		'd2u_machinery_form_phone' => 'Teléfono',
		'd2u_machinery_form_please_call' => 'Solicitar una llamada telefónica',
		'd2u_machinery_form_position' => 'Sector de actividad',
		'd2u_machinery_form_privacy_policy' => 'Doy mi consentimiento para que el usuario del sitio web almacene y procese mis datos de contacto y uso. Conozco el alcance del procesamiento de datos <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> aquí </a>. Tengo derecho a oponerme a este uso en cualquier momento en los detalles de contacto proporcionados en el <a href="+++LINK_IMPRESS+++" target="_blank"> pie de página </a>.',
		'd2u_machinery_form_required' => 'Necesario',
		'd2u_machinery_form_send' => 'Enviar',
		'd2u_machinery_form_thanks' => 'Gracias por su consulta. En breve nos pondremos en contacto con usted.',
		'd2u_machinery_form_validate_address' => 'Por favor, introduzca su dirección.',
		'd2u_machinery_form_validate_city' => 'Por favor, introduzca su Ciudad.',
		'd2u_machinery_form_validate_country' => 'Por favor, introduzca su país.',
		'd2u_machinery_form_validate_email' => 'Por favor, introduzca una dirección válida de correo electrónico.',
		'd2u_machinery_form_validate_name' => 'Por favor, introduzca su apellido',
		'd2u_machinery_form_validate_phone' => 'Por favor, introduzca su número de teléfono.',
		'd2u_machinery_form_validate_privacy_policy' => 'La política de privacidad debe ser aprobada.',
		'd2u_machinery_form_validate_spambots' => 'Protección contra spam: tome al menos 10 segundos para completar el formulario.',
		'd2u_machinery_form_validate_spam_detected' => 'Su mensaje fue clasificado como spam, porque no se completaron los campos visibles.',
		'd2u_machinery_form_validate_title' => 'Por favor, compruebe sus datos y corríjalos si es necesario.',
		'd2u_machinery_form_validate_zip' => 'Por favor, introduzca su C.P.',
		'd2u_machinery_form_vorname' => 'Nombre',
		'd2u_machinery_form_zip' => 'Código Postal',
		'd2u_machinery_no_machines' => 'No se encontraron máquinas.',
		'd2u_machinery_operating_voltage' => 'Tensión de servicio',
		'd2u_machinery_our_products' => 'Nuestras máquinas',
		'd2u_machinery_overview' => 'Máquina',
		'd2u_machinery_pics' => 'Imágenes',
		'd2u_machinery_productfinder_heading' => 'Buscador de productos',
		'd2u_machinery_productfinder_text' => 'Encontrar exactamente su producto',
		'd2u_machinery_references' => 'Cartas credenciales',
		'd2u_machinery_request' => 'Solicitud',
		'd2u_machinery_service' => 'Detalles del servicio',
		'd2u_machinery_software' => 'Software',
		'd2u_machinery_tech_data' => 'Especificaciones técnicas',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_ca' => 'aprox.',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'Pieza',
		'd2u_machinery_unit_rotations_min' => 'r/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Operaciones',
		'd2u_machinery_video' => 'Vídeo',
		'd2u_machinery_weight' => 'Peso'
	];

	/**
	 * @var string[] Array with italian replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_italian = [
		'd2u_machinery_advantages' => 'I vantaggi in un colpo d\'occhio',
		'd2u_machinery_alternative_machines' => 'Macchine alternative',
		'd2u_machinery_back_machine_list' => 'Torna all\'elenco delle macchine',
		'd2u_machinery_consultation_heading' => 'Lasciatevi consigliare da noi',
		'd2u_machinery_consultation_hint' => 'Offriamo la soluzione ottimale per le tue esigenze.<br><b>Contattaci.</b>',
		'd2u_machinery_consultation_link_machine' => 'Alla richiesta della macchina',
		'd2u_machinery_consultation_link_personal' => 'Per consulenza personale',
		'd2u_machinery_consultation_text' => 'Ti aiutiamo a trovare il<br> product destra.',
		'd2u_machinery_dimensions_length' => 'Lunghezza',
		'd2u_machinery_dimensions_length_width_height' => 'Dimensioni (lungh.&nbsp;x&nbsp;largh.&nbsp;x&nbsp;alt.)',
		'd2u_machinery_dimensions_width_height_depth' => 'Dimensioni (largh.&nbsp;x&nbsp;alt.&nbsp;x&nbsp;prof.)',
		'd2u_machinery_downloads' => 'Download',
		'd2u_machinery_engine_power' => 'Potenza del motore',
		'd2u_machinery_engine_power_frequency_controlled' => 'frequenza controllata',
		'd2u_machinery_form_address' => 'Indirizzo',
		'd2u_machinery_form_city' => 'Località',
		'd2u_machinery_form_company' => 'Ditta',
		'd2u_machinery_form_country' => 'Paese',
		'd2u_machinery_form_email' => 'E-mail',
		'd2u_machinery_form_fax' => 'Fax',
		'd2u_machinery_form_message' => 'Osservazione',
		'd2u_machinery_form_name' => 'Cognome',
		'd2u_machinery_form_phone' => 'Telefono',
		'd2u_machinery_form_please_call' => 'Prego di richiamarmi',
		'd2u_machinery_form_position' => 'Campo di attività',
		'd2u_machinery_form_privacy_policy' => 'Acconsento alla memorizzazione e all\'elaborazione dei miei dati di contatto e utilizzo da parte dell\'operatore del sito web. Ho appreso l\'ambito dell\'elaborazione dei dati <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> qui </a>. Ho il diritto di oppormi a questo utilizzo in qualsiasi momento con i dettagli di contatto forniti nella <a href="+++LINK_IMPRESS+++" target="_blank"> impronta </a>.',
		'd2u_machinery_form_required' => 'Richiesto',
		'd2u_machinery_form_send' => 'Invia',
		'd2u_machinery_form_thanks' => 'Molte grazie per la Sua richiesta. Ce ne occuperemo il più presto possibile.',
		'd2u_machinery_form_validate_address' => 'La si prega di digitare il Suo indirizzo.',
		'd2u_machinery_form_validate_city' => 'La si prega di digitare la Sua località.',
		'd2u_machinery_form_validate_country' => 'La si prega di digitare il Suo paese.',
		'd2u_machinery_form_validate_email' => 'Digiti un indirizzo e-mail corretto.',
		'd2u_machinery_form_validate_name' => 'La si prega di digitare il Suo cognome',
		'd2u_machinery_form_validate_phone' => 'La si prega di digitare il Suo numero di telefono.',
		'd2u_machinery_form_validate_privacy_policy' => 'L\'informativa sulla privacy deve essere approvata.',
		'd2u_machinery_form_validate_spam_detected' => 'Il tuo messaggio è stato classificato come spam, perché i campi non visibili sono stati compilati.',
		'd2u_machinery_form_validate_spambots' => 'Protezione antispam: impiegare almeno 10 secondi per compilare il modulo.',
		'd2u_machinery_form_validate_title' => 'Siete pregati di verificare i dati immessi e di correggerli all’occorrenza.',
		'd2u_machinery_form_validate_zip' => 'La si prega di digitare il Suo CAP.',
		'd2u_machinery_form_vorname' => 'Nome',
		'd2u_machinery_form_zip' => 'CAP',
		'd2u_machinery_no_machines' => 'Nessuna macchina trovata',
		'd2u_machinery_operating_voltage' => 'Tensione di esercizio',
		'd2u_machinery_our_products' => 'Le nostre macchine',
		'd2u_machinery_overview' => 'Macchina',
		'd2u_machinery_pics' => 'Immagini',
		'd2u_machinery_productfinder_heading' => 'I nostri prodotti',
		'd2u_machinery_productfinder_text' => 'Trova esattamente il vostro prodotto',
		'd2u_machinery_references' => 'Credenziali',
		'd2u_machinery_request' => 'Richiesta',
		'd2u_machinery_service' => 'Dettagli del servizio',
		'd2u_machinery_software' => 'Software',
		'd2u_machinery_tech_data' => 'Dati tecnici',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_ca' => 'ca.',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'pezzi',
		'd2u_machinery_unit_rotations_min' => 'r/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Operazioni',
		'd2u_machinery_video' => 'Video',
		'd2u_machinery_weight' => 'Peso'
	];

	/**
	 * @var string[] Array with polish replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_polish = [
		'd2u_machinery_advantages' => 'Zalety w skrócie',
		'd2u_machinery_alternative_machines' => 'Maszyny alternatywne',
		'd2u_machinery_back_machine_list' => 'Powrót do listy maszyn',
		'd2u_machinery_consultation_heading' => 'Pozwól nam doradzić',
		'd2u_machinery_consultation_hint' => 'Zapewniamy optymalne rozwiązanie dla Twoich potrzeb.<br><b>Skontaktuj się z nami.</b>',
		'd2u_machinery_consultation_link_machine' => 'Do zapytania maszyny.',
		'd2u_machinery_consultation_link_personal' => 'Dla doradztwa osobistego',
		'd2u_machinery_consultation_text' => 'Pomożemy Ci znaleźć odpowiedni<br> Foto produkt.',
		'd2u_machinery_dimensions_length' => 'Długość',
		'd2u_machinery_dimensions_length_width_height' => 'Wymiary (dł.&nbsp;x&nbsp;szer.&nbsp;x&nbsp;wys.)',
		'd2u_machinery_dimensions_width_height_depth' => 'Wymiary (szer&nbsp;x&nbsp;wys.&nbsp;x&nbsp;głęb.)',
		'd2u_machinery_downloads' => 'Pliki do pobrania',
		'd2u_machinery_engine_power' => 'Moc silnika ',
		'd2u_machinery_engine_power_frequency_controlled' => 'częstotliwość kontrolowana',
		'd2u_machinery_form_address' => 'Adres',
		'd2u_machinery_form_city' => 'Miejscowość',
		'd2u_machinery_form_company' => 'Firmy',
		'd2u_machinery_form_country' => 'Kraj',
		'd2u_machinery_form_email' => 'Email',
		'd2u_machinery_form_fax' => 'Faks',
		'd2u_machinery_form_message' => 'Uwaga',
		'd2u_machinery_form_name' => 'Nazwisko',
		'd2u_machinery_form_phone' => 'Telefon',
		'd2u_machinery_form_please_call' => 'Proszę o kontakt telefoniczny',
		'd2u_machinery_form_position' => 'Zakres działania',
		'd2u_machinery_form_privacy_policy' => 'Wyrażam zgodę na przechowywanie i przetwarzanie moich danych kontaktowych i użytkowych przez operatora strony internetowej. Dowiedziałem się o zakresie przetwarzania danych <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> tutaj </a>. Mam prawo w każdej chwili wyrazić sprzeciw wobec tego użycia pod danymi kontaktowymi podanymi w <a href="+++LINK_IMPRESS+++" target="_blank"> odciskach </a>.',
		'd2u_machinery_form_required' => 'Wymagany',
		'd2u_machinery_form_send' => 'Wysłać',
		'd2u_machinery_form_thanks' => 'Bardzo dziękujemy za zapytanie. Odpowiemy na nie najszybciej, jak to możliwe.',
		'd2u_machinery_form_validate_address' => 'Prosimy o podanie nazwy Adres.',
		'd2u_machinery_form_validate_city' => 'Prosimy o podanie nazwy Miejscowość.',
		'd2u_machinery_form_validate_country' => 'Prosimy o wybranie swojego kraju.',
		'd2u_machinery_form_validate_email' => 'Prosimy o sprawdzenie i skorygowanie adresu e-mail.',
		'd2u_machinery_form_validate_name' => 'Prosimy wpisać Państwa Nazwisko',
		'd2u_machinery_form_validate_phone' => 'Prosimy o podanie nazwy Telefon.',
		'd2u_machinery_form_validate_privacy_policy' => 'Polityka prywatności musi zostać zatwierdzona.',
		'd2u_machinery_form_validate_spam_detected' => 'Twoja wiadomość została sklasyfikowana jako spam, ponieważ niewidoczne pola zostały wypełnione.',
		'd2u_machinery_form_validate_spambots' => 'Ochrona przed spamem: wypełnij formularz przez co najmniej 10 sekund.',
		'd2u_machinery_form_validate_title' => 'Proszę sprawdzić swoje dane i w razie potrzeby skorygować.',
		'd2u_machinery_form_validate_zip' => 'Prosimy o podanie nazwy Kod pocztowy.',
		'd2u_machinery_form_vorname' => 'Imię',
		'd2u_machinery_form_zip' => 'Kod pocztowy',
		'd2u_machinery_no_machines' => 'Nie znaleziono maszyn.',
		'd2u_machinery_operating_voltage' => 'Napięcie robocze',
		'd2u_machinery_our_products' => 'Nasze maszyny ',
		'd2u_machinery_overview' => 'Maszyna',
		'd2u_machinery_pics' => 'Zdjęcia',
		'd2u_machinery_productfinder_heading' => 'Wyszukiwarka produktów',
		'd2u_machinery_productfinder_text' => 'Znajdź dokładnie produkt',
		'd2u_machinery_references' => 'Listy uwierzytelniające',
		'd2u_machinery_request' => 'Zapytanie ofertowe',
		'd2u_machinery_service' => 'Szczegóły usługi',
		'd2u_machinery_software' => 'Oprogramowanie',
		'd2u_machinery_tech_data' => 'Dane techniczne ',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_ca' => 'przybliżeniu',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'sztuk',
		'd2u_machinery_unit_rotations_min' => 'r/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Operacje',
		'd2u_machinery_video' => 'Wideo',
		'd2u_machinery_weight' => 'Waga'
	];
	
	/**
	 * @var string[] Array with dutch replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_dutch = [
		'd2u_machinery_advantages' => 'Voordelen in een oogopslag',
		'd2u_machinery_alternative_machines' => 'Alternatieve machines',
		'd2u_machinery_back_machine_list' => 'Terug naar de machinelijst',
		'd2u_machinery_consultation_heading' => 'Laat ons u adviseren',
		'd2u_machinery_consultation_hint' => 'Wij bieden de optimale oplossing voor uw behoeften.<br><b>Neem contact met ons op.</b>',
		'd2u_machinery_consultation_link_machine' => 'Naar de machine-aanvraag.',
		'd2u_machinery_consultation_link_personal' => 'Voor persoonlijk advies',
		'd2u_machinery_consultation_text' => 'Wij helpen u de juiste <br> product te vinden.',
		'd2u_machinery_dimensions_length' => 'Lengte',
		'd2u_machinery_dimensions_length_width_height' => 'Afmetingen (l&nbsp;x&nbsp;b&nbsp;x&nbsp;h) ',
		'd2u_machinery_dimensions_width_height_depth' => 'Afmetingen (b&nbsp;x&nbsp;h&nbsp;x&nbsp;d)',
		'd2u_machinery_downloads' => 'Downloads',
		'd2u_machinery_engine_power' => 'Motorvermogen ',
		'd2u_machinery_engine_power_frequency_controlled' => 'frequentiegestuurd',
		'd2u_machinery_form_address' => 'Adres',
		'd2u_machinery_form_city' => 'Plaats',
		'd2u_machinery_form_company' => 'Vennootschap',
		'd2u_machinery_form_country' => 'Land',
		'd2u_machinery_form_email' => 'E-Mail',
		'd2u_machinery_form_fax' => 'Telefax',
		'd2u_machinery_form_message' => 'Opmerking',
		'd2u_machinery_form_name' => 'Achternaam',
		'd2u_machinery_form_phone' => 'Telefoon',
		'd2u_machinery_form_please_call' => 'Verzoek om telefonische contactopname',
		'd2u_machinery_form_position' => 'Werkterrein',
		'd2u_machinery_form_privacy_policy' => 'Ik stem in met de opslag en verwerking van mijn contactgegevens en gebruiksgegevens door de exploitant van de website. Ik heb kennisgemaakt over de reikwijdte van de gegevensverwerking <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> hier </a>. Ik heb het recht om op elk moment bezwaar te maken tegen dit gebruik onder de contactgegevens in de <a href="+++LINK_IMPRESS+++" target="_blank"> impressum </a>.',
		'd2u_machinery_form_required' => 'Nodig',
		'd2u_machinery_form_send' => 'Versturen',
		'd2u_machinery_form_thanks' => 'Hartelijk dank voor uw aanvraag. Wij zullen deze zo snel mogelijk in behandeling nemen.',
		'd2u_machinery_form_validate_address' => 'Voer uw adres in.',
		'd2u_machinery_form_validate_city' => 'Voer uw plaats.',
		'd2u_machinery_form_validate_country' => 'Voer uw land.',
		'd2u_machinery_form_validate_email' => 'Voer uw e-mailadres.',
		'd2u_machinery_form_validate_name' => 'Voer uw achternaam in, a.u.b.',
		'd2u_machinery_form_validate_phone' => 'Voer uw telefoonnummer in.',
		'd2u_machinery_form_validate_privacy_policy' => 'Het privacybeleid moet worden goedgekeurd.',
		'd2u_machinery_form_validate_spam_detected' => 'Uw bericht is geclassificeerd als spam, omdat niet zichtbare velden zijn ingevuld.',
		'd2u_machinery_form_validate_spambots' => 'Spambeveiliging: neem ten minste 10 seconden de tijd om het formulier in te vullen.',
		'd2u_machinery_form_validate_title' => 'Controleer uw gegevens en corrigeer deze eventueel a.u.b.',
		'd2u_machinery_form_validate_zip' => 'Voer uw postcode in.',
		'd2u_machinery_form_vorname' => 'Voornaam',
		'd2u_machinery_form_zip' => 'Postcode',
		'd2u_machinery_no_machines' => 'Geen machines gevonden.',
		'd2u_machinery_operating_voltage' => 'Bedrijfsspanning',
		'd2u_machinery_our_products' => 'Onze machines',
		'd2u_machinery_overview' => 'Machine',
		'd2u_machinery_pics' => 'Afbeeldingen',
		'd2u_machinery_productfinder_heading' => 'Productvinder',
		'd2u_machinery_productfinder_text' => 'Vind precies uw product',
		'd2u_machinery_references' => 'Geloofsbrieven',
		'd2u_machinery_request' => 'Aanvraag',
		'd2u_machinery_service' => 'Servicedetails',
		'd2u_machinery_software' => 'Software',
		'd2u_machinery_tech_data' => 'Technische gegevens',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_ca' => 'ca.',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'Stuks',
		'd2u_machinery_unit_rotations_min' => 'r/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Operaties',
		'd2u_machinery_video' => 'Video',
		'd2u_machinery_weight' => 'Gewicht'
	];

	/**
	 * @var string[] Array with czech replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_czech = [
		'd2u_machinery_advantages' => 'Výhody na první pohled',
		'd2u_machinery_alternative_machines' => 'alternativní stroje',
		'd2u_machinery_back_machine_list' => 'Zpět na seznam zařízení',
		'd2u_machinery_consultation_heading' => 'Dovolte nám, abychom Vás poradit',
		'd2u_machinery_consultation_hint' => 'Poskytujeme optimální řešení pro vaše potřeby.<br><b>Kontaktujte nás.</b>',
		'd2u_machinery_consultation_link_machine' => 'Na dotaz stroje',
		'd2u_machinery_consultation_link_personal' => 'Pro osobní poradenství',
		'd2u_machinery_consultation_text' => 'Pomůžeme vám najít ten správný klipart<br> produkt.',
		'd2u_machinery_dimensions_length' => 'Délka',
		'd2u_machinery_dimensions_length_width_height' => 'Rozměry (d&nbsp;x&nbsp;š&nbsp;x&nbsp;v)',
		'd2u_machinery_dimensions_width_height_depth' => 'Rozměry (š&nbsp;x&nbsp;v&nbsp;x&nbsp;h)',
		'd2u_machinery_downloads' => 'Stahování',
		'd2u_machinery_engine_power' => 'Výkon motoru',
		'd2u_machinery_engine_power_frequency_controlled' => 'frekvenčně řízený',
		'd2u_machinery_form_address' => 'Adresa',
		'd2u_machinery_form_city' => 'Město',
		'd2u_machinery_form_company' => 'Spółka',
		'd2u_machinery_form_country' => 'Země',
		'd2u_machinery_form_email' => 'emailovou adresu',
		'd2u_machinery_form_fax' => 'Fax',
		'd2u_machinery_form_message' => 'Poznámka',
		'd2u_machinery_form_name' => 'Příjmení',
		'd2u_machinery_form_phone' => 'Telefon',
		'd2u_machinery_form_please_call' => 'Prosím o zavolání zpět',
		'd2u_machinery_form_position' => 'Obor činnosti',
		'd2u_machinery_form_privacy_policy' => 'Souhlasím s uložením a zpracováním údajů o kontaktech a užití provozovatelem webových stránek. Naučila jsem se o rozsahu zpracování dat <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> zde </a>. Mám právo kdykoli podat námitku proti tomuto použití v rámci kontaktních údajů uvedených v <a href="+++LINK_IMPRESS+++" target="_blank"> tisku </a>.',
		'd2u_machinery_form_required' => 'Potřebný',
		'd2u_machinery_form_send' => 'Odeslat',
		'd2u_machinery_form_thanks' => 'Děkujeme za Vaši poptávku. Zpracujeme ji, jak nejrychleji to bude možné.',
		'd2u_machinery_form_validate_address' => 'Prosím zadejte Vaši adresu.',
		'd2u_machinery_form_validate_city' => 'Prosím zadejte Vaše město/obec.',
		'd2u_machinery_form_validate_company' => 'Prosím, zadejte jméno Vaší společnosti.',
		'd2u_machinery_form_validate_country' => 'Prosím zvolte zemi.',
		'd2u_machinery_form_validate_email' => 'Prosím zadejte správnou emailovou adresu.',
		'd2u_machinery_form_validate_name' => 'Prosím, zadejte své příjmení.',
		'd2u_machinery_form_validate_phone' => 'Prosím zadejte Vaše telefoní číslo.',
		'd2u_machinery_form_validate_privacy_policy' => 'Zásady ochrany osobních údajů musí být schváleny.',
		'd2u_machinery_form_validate_spam_detected' => 'Vaše zpráva byla klasifikována jako spam, protože nebyla vyplněna neviditelná pole.',
		'd2u_machinery_form_validate_spambots' => 'Ochrana proti spamu: vyplňte formulář nejméně 10 vteřin.',
		'd2u_machinery_form_validate_title' => 'Prosím zkontrolujte údaje a případně je opravte.',
		'd2u_machinery_form_validate_zip' => 'Prosím zadejte Vaše PSČ.',
		'd2u_machinery_form_vorname' => 'Jméno',
		'd2u_machinery_form_zip' => 'PSČ',
		'd2u_machinery_no_machines' => 'Nenalezeny žádné stroje',
		'd2u_machinery_operating_voltage' => 'Provozní napětí',
		'd2u_machinery_our_products' => 'Naše stroje',
		'd2u_machinery_overview' => 'stroj',
		'd2u_machinery_pics' => 'Obrázky',
		'd2u_machinery_productfinder_heading' => 'Najděte si svůj výrobek',
		'd2u_machinery_productfinder_text' => 'Najděte přesně svůj výrobek',
		'd2u_machinery_references' => 'Pověřovací listiny',
		'd2u_machinery_request' => 'poptávka',
		'd2u_machinery_service' => 'Podrobnosti o službách',
		'd2u_machinery_software' => 'Software',
		'd2u_machinery_tech_data' => 'Technické údaje',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_ca' => 'přibližně',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_diameter_mm' => 'Ø mm',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'ks',
		'd2u_machinery_unit_rotations_min' => 'o/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Operace',
		'd2u_machinery_video' => 'Video',
		'd2u_machinery_weight' => 'Závaží'
	];

	/**
	 * @var string[] Array with russian replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_russian = [
		'd2u_machinery_advantages' => 'Основные преимущества',
		'd2u_machinery_alternative_machines' => 'Альтернативные станки',
		'd2u_machinery_back_machine_list' => 'Вернуться к списку оборудования',
		'd2u_machinery_consultation_heading' => 'Получите консультацию специалиста',
		'd2u_machinery_consultation_hint' => 'Мы предлагаем оптимальное решение для Вашего производства.<br><b>Свяжитесь с нами.</b>',
		'd2u_machinery_consultation_link_machine' => 'Отправить запрос',
		'd2u_machinery_consultation_link_personal' => 'Отправить запрос',
		'd2u_machinery_consultation_text' => 'Мы поможем Вам подобрать оборудование <br> в соответствии с техническими требованиями Вашего производства.',
		'd2u_machinery_dimensions_length' => 'длина',
		'd2u_machinery_dimensions_length_width_height' => 'габариты (д&nbsp;x&nbsp;ш&nbsp;x&nbsp;в) ',
		'd2u_machinery_dimensions_width_height_depth' => 'Размеры (ш&nbsp;x&nbsp;в&nbsp;x&nbsp;г) ',
		'd2u_machinery_downloads' => 'Загрузки',
		'd2u_machinery_engine_power' => 'мощность двигателя',
		'd2u_machinery_engine_power_frequency_controlled' => 'с регулируемой частотой',
		'd2u_machinery_form_address' => 'Адрес',
		'd2u_machinery_form_city' => 'Город',
		'd2u_machinery_form_company' => 'Компания',
		'd2u_machinery_form_country' => 'Страна',
		'd2u_machinery_form_email' => 'Электронная почта',
		'd2u_machinery_form_fax' => 'Телефакс',
		'd2u_machinery_form_message' => 'Примечание',
		'd2u_machinery_form_name' => 'Фамилия',
		'd2u_machinery_form_phone' => 'Телефон',
		'd2u_machinery_form_please_call' => 'Заказать обратный звонок',
		'd2u_machinery_form_position' => 'Сфера деятельности',
		'd2u_machinery_form_privacy_policy' => 'Я соглашаюсь на хранение и обработку моих данных о контактах и использовании оператором веб-сайта. Я узнал о масштабах обработки данных <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> здесь </a>. Я имею право возражать против этого использования в любое время по контактным данным, указанным в <a href="+++LINK_IMPRESS+++" target="_blank"> отпечатке </a>.',
		'd2u_machinery_form_required' => 'поля, обязательные для заполнения',
		'd2u_machinery_form_send' => 'Отправить',
		'd2u_machinery_form_thanks' => 'Благодарим Вас за запрос. Наши специалисты ответят Вам в ближайшее время.',
		'd2u_machinery_form_validate_address' => 'Пожалуйста, введите Ваш адрес.',
		'd2u_machinery_form_validate_city' => 'Пожалуйста, введите название Вашего населённого пункта.',
		'd2u_machinery_form_validate_company' => 'Укажите название компании.',
		'd2u_machinery_form_validate_country' => 'Пожалуйста, введите Вашу страну.',
		'd2u_machinery_form_validate_email' => 'Пожалуйста, укажите правильный адрес электронной почты.',
		'd2u_machinery_form_validate_name' => 'Введите свою фамилию.',
		'd2u_machinery_form_validate_phone' => 'Пожалуйста, введите Ваш номер телефона.',
		'd2u_machinery_form_validate_privacy_policy' => 'Политика конфиденциальности должна быть одобрена.',
		'd2u_machinery_form_validate_spam_detected' => 'Ваше сообщение было классифицировано как спам, потому что невидимые поля были заполнены.',
		'd2u_machinery_form_validate_spambots' => 'Защита от спама: заполните, пожалуйста, не менее 10 секунд.',
		'd2u_machinery_form_validate_title' => 'Пожалуйста, проверьте Ваши данные и в случае необходимости откорректируйте их.',
		'd2u_machinery_form_validate_zip' => 'Пожалуйста, введите Ваш почтовый индекс.',
		'd2u_machinery_form_vorname' => 'Имя',
		'd2u_machinery_form_zip' => 'Почтовый код',
		'd2u_machinery_no_machines' => 'Оборудование не найдено',
		'd2u_machinery_operating_voltage' => 'рабочее напряжение',
		'd2u_machinery_our_products' => 'Наше оборудование',
		'd2u_machinery_overview' => 'Оборудование',
		'd2u_machinery_pics' => 'Фотографии',
		'd2u_machinery_productfinder_heading' => 'Поиск оборудования',
		'd2u_machinery_productfinder_text' => 'Подобрать оборудование',
		'd2u_machinery_references' => 'полномочия',
		'd2u_machinery_request' => 'запрос',
		'd2u_machinery_service' => 'Сведения об услугах',
		'd2u_machinery_software' => 'Программное обеспечение',
		'd2u_machinery_tech_data' => 'Технические характеристики',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) мм',
		'd2u_machinery_unit_bar' => 'бар',
		'd2u_machinery_unit_ca' => 'примерно',
		'd2u_machinery_unit_cm' => 'см',
		'd2u_machinery_unit_cm2' => 'см²',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_diameter_mm' => 'Ø мм',
		'd2u_machinery_unit_hz' => 'Гц',
		'd2u_machinery_unit_kg' => 'кг',
		'd2u_machinery_unit_kg_m' => 'кг / м',
		'd2u_machinery_unit_kn' => 'кН',
		'd2u_machinery_unit_kw' => 'кВт',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'л/мин',
		'd2u_machinery_unit_m' => 'м',
		'd2u_machinery_unit_m2_h' => 'м²/ч',
		'd2u_machinery_unit_m_min' => 'м/мин',
		'd2u_machinery_unit_min1' => 'мин-1',
		'd2u_machinery_unit_mm' => 'мм',
		'd2u_machinery_unit_mm_min' => 'мм/мин',
		'd2u_machinery_unit_pieces' => 'шт.',
		'd2u_machinery_unit_rotations_min' => 'оборотов/минуту',
		'd2u_machinery_unit_v' => 'В',
		'd2u_machinery_usage_areas' => 'операции',
		'd2u_machinery_video' => 'видео',
		'd2u_machinery_weight' => 'вес',
	];

	/**
	 * @var string[] Array with portuguese replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_portuguese = [
		'd2u_machinery_advantages' => 'Resumo das vantagens',
		'd2u_machinery_alternative_machines' => 'Máquinas alternativas',
		'd2u_machinery_back_machine_list' => 'De volta à lista de máquinas',
		'd2u_machinery_consultation_heading' => 'Vamos orientá-lo',
		'd2u_machinery_consultation_hint' => 'Fornecemos a solução ideal para suas necessidades.<br><b>Entre em contato.</b>',
		'd2u_machinery_consultation_link_machine' => 'Para o inquérito da máquina.',
		'd2u_machinery_consultation_link_personal' => 'Para consultoria pessoal',
		'd2u_machinery_consultation_text' => 'Nós ajudá-lo a encontrar o <br> produto certo.',
		'd2u_machinery_dimensions_length' => 'Comprimento',
		'd2u_machinery_dimensions_length_width_height' => 'Dimensões (C&nbsp;x&nbsp;L&nbsp;x&nbsp;A)',
		'd2u_machinery_dimensions_width_height_depth' => 'Dimensões (L&nbsp;x&nbsp;A&nbsp;x&nbsp;P',
		'd2u_machinery_downloads' => 'De downloads',
		'd2u_machinery_engine_power' => 'Potência do motor',
		'd2u_machinery_engine_power_frequency_controlled' => 'freqüência controlada',
		'd2u_machinery_form_address' => 'Endereço',
		'd2u_machinery_form_city' => 'Localidade',
		'd2u_machinery_form_company' => 'Empresa',
		'd2u_machinery_form_country' => 'País',
		'd2u_machinery_form_email' => 'E-Mail',
		'd2u_machinery_form_fax' => 'Fax',
		'd2u_machinery_form_message' => 'Observação',
		'd2u_machinery_form_name' => 'Apelido',
		'd2u_machinery_form_phone' => 'Telefone',
		'd2u_machinery_form_please_call' => 'Solicitar contacto',
		'd2u_machinery_form_position' => 'Área de actividade',
		'd2u_machinery_form_privacy_policy' => 'Eu concordo com o armazenamento e processamento dos meus dados de contato e uso pelo operador do site. Aprendi sobre o escopo do processamento de dados <a href="+++LINK_PRIVACY_POLICY+++" target="_blank"> aqui </a>. Tenho o direito de me opor a esse uso a qualquer momento sob os detalhes de contato fornecidos na <a href="+++LINK_IMPRESS++++ target="_blank"> impressão </a>.',
		'd2u_machinery_form_required' => 'Exigido',
		'd2u_machinery_form_send' => 'Enviar',
		'd2u_machinery_form_thanks' => 'Obrigado pela sua consulta. Iremos processar a mesma o mais rapidamente possível.',
		'd2u_machinery_form_validate_address' => 'Introduza a sua morada.',
		'd2u_machinery_form_validate_city' => 'Introduza a sua localidade.',
		'd2u_machinery_form_validate_country' => 'Introduza o seu país.',
		'd2u_machinery_form_validate_email' => 'Introduza um endereço electrónico correcto.',
		'd2u_machinery_form_validate_name' => 'Introduza o seu apelido',
		'd2u_machinery_form_validate_phone' => 'Introduza o seu número de telefone.',
		'd2u_machinery_form_validate_privacy_policy' => 'A política de privacidade deve ser aprovada.',
		'd2u_machinery_form_validate_spam_detected' => 'Sua mensagem foi classificada como spam, porque campos não visíveis foram preenchidos.',
		'd2u_machinery_form_validate_spambots' => 'Proteção contra spam: leve pelo menos 10 segundos para preencher o formulário.',
		'd2u_machinery_form_validate_title' => 'Verifique as suas informações e se necessário corrija-as.',
		'd2u_machinery_form_validate_zip' => 'Introduza o seu código postal.',
		'd2u_machinery_form_vorname' => 'Nome',
		'd2u_machinery_form_zip' => 'Código Postal',
		'd2u_machinery_no_machines' => 'Nenhuma máquina encontrada.',
		'd2u_machinery_operating_voltage' => 'Tensão de operação',
		'd2u_machinery_our_products' => 'As nossas máquinas',
		'd2u_machinery_overview' => 'Máquina',
		'd2u_machinery_pics' => 'Pictures',
		'd2u_machinery_productfinder_heading' => 'Encontre o seu produto',
		'd2u_machinery_productfinder_text' => 'Encontre exatamente o seu produto',
		'd2u_machinery_references' => 'Credenciais',
		'd2u_machinery_request' => 'Consulta',
		'd2u_machinery_service' => 'Detalhes do serviço',
		'd2u_machinery_software' => 'Programa de computador',
		'd2u_machinery_tech_data' => 'Dados técnicos',
		'd2u_machinery_unit_a' => 'A',
		'd2u_machinery_unit_a_mm' => '(a) mm',
		'd2u_machinery_unit_bar' => 'bar',
		'd2u_machinery_unit_ca' => 'aprox.',
		'd2u_machinery_unit_cm' => 'cm',
		'd2u_machinery_unit_cm2' => 'cm²',
		'd2u_machinery_unit_diameter_mm' => 'mm',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => 'Hz',
		'd2u_machinery_unit_kg' => 'kg',
		'd2u_machinery_unit_kg_m' => 'kg/m',
		'd2u_machinery_unit_kn' => 'kN',
		'd2u_machinery_unit_kw' => 'kW',
		'd2u_machinery_unit_l' => 'l',
		'd2u_machinery_unit_l_min' => 'l/min',
		'd2u_machinery_unit_m' => 'm',
		'd2u_machinery_unit_m2_h' => 'm²/h',
		'd2u_machinery_unit_m_min' => 'm/min',
		'd2u_machinery_unit_min1' => 'min-1',
		'd2u_machinery_unit_mm' => 'mm',
		'd2u_machinery_unit_mm_min' => 'mm/min',
		'd2u_machinery_unit_pieces' => 'Qtd.',
		'd2u_machinery_unit_rotations_min' => 'r/min',
		'd2u_machinery_unit_v' => 'V',
		'd2u_machinery_usage_areas' => 'Operações',
		'd2u_machinery_video' => 'Vídeo',
		'd2u_machinery_weight' => 'Peso'
	];

	/**
	 * @var string[] Array with chinese replacements. Key is the wildcard,
	 * value the replacement. 
	 */
	protected $replacements_chinese = [
		'd2u_machinery_advantages' => '显而易见的优势',
		'd2u_machinery_alternative_machines' => '替代机器',
		'd2u_machinery_back_machine_list' => '回到機器列表',
		'd2u_machinery_consultation_heading' => '请获取建议',
		'd2u_machinery_consultation_hint' => '我們為您的需求提供最佳解決方案。<br><b>聯繫我們。</b>',
		'd2u_machinery_consultation_link_machine' => '机器询价',
		'd2u_machinery_consultation_link_personal' => '个人咨询',
		'd2u_machinery_consultation_text' => '我们将帮助您找到合适的产品。',
		'd2u_machinery_dimensions_length' => '长',
		'd2u_machinery_dimensions_length_width_height' => '体积（长度x宽度x高度）',
		'd2u_machinery_dimensions_width_height_depth' => '体积（宽度x高度x深度）',
		'd2u_machinery_downloads' => '新用户/改装套件',
		'd2u_machinery_engine_power' => '电机功率',
		'd2u_machinery_engine_power_frequency_controlled' => '频率控制',
		'd2u_machinery_form_address' => '路名/门牌号',
		'd2u_machinery_form_city' => '所在地',
		'd2u_machinery_form_company' => '公司',
		'd2u_machinery_form_country' => '国家',
		'd2u_machinery_form_email' => '电子邮箱地址',
		'd2u_machinery_form_fax' => '传真',
		'd2u_machinery_form_message' => '备注',
		'd2u_machinery_form_name' => '名称',
		'd2u_machinery_form_phone' => '电话',
		'd2u_machinery_form_please_call' => '请求致电',
		'd2u_machinery_form_position' => '职能',
		'd2u_machinery_form_privacy_policy' => '我同意网站运营商存储和处理我的联系和使用数据。 我已经了解了<a href="+++LINK_PRIVACY_POLICY+++" target="_blank">此处</a>的数据处理范围。 我有权随时根据<a href="+++LINK_IMPRESS+++" target="_blank">版本说明</a>中提供的联系信息反对此用途。',
		'd2u_machinery_form_required' => '必填项',
		'd2u_machinery_form_send' => '发送',
		'd2u_machinery_form_thanks' => '非常感谢您提供的信息。我们将尽快处理您的请求。',
		'd2u_machinery_form_validate_address' => '请输入您的地址。',
		'd2u_machinery_form_validate_city' => '请输入您的所在地。',
		'd2u_machinery_form_validate_company' => '请输入您的公司名',
		'd2u_machinery_form_validate_country' => '请输入您所在的国家。',
		'd2u_machinery_form_validate_email' => '请输入您的电子邮箱地址。',
		'd2u_machinery_form_validate_name' => '请输入您的姓氏。',
		'd2u_machinery_form_validate_phone' => '请输入您的电话号码。',
		'd2u_machinery_form_validate_privacy_policy' => '隱私政策必須獲得批准。',
		'd2u_machinery_form_validate_spam_detected' => '您的邮件被归类为垃圾邮件，因为未填写可见字段。',
		'd2u_machinery_form_validate_spambots' => '垃圾邮件保护：请至少花10秒钟填写表格。',
		'd2u_machinery_form_validate_title' => '请检查您输入的内容，并进行相应的修改。',
		'd2u_machinery_form_validate_zip' => '请输入您的邮编。',
		'd2u_machinery_form_vorname' => '名字',
		'd2u_machinery_form_zip' => '邮编',
		'd2u_machinery_no_machines' => '对不起 目前我们没有机器可用。 请稍后再试。',
		'd2u_machinery_operating_voltage' => '工作电压',
		'd2u_machinery_our_products' => '最适合您应用的设备和机器',
		'd2u_machinery_overview' => '机器',
		'd2u_machinery_pics' => '图片',
		'd2u_machinery_productfinder_heading' => '产品搜索器',
		'd2u_machinery_productfinder_text' => '找到您的理想产品',
		'd2u_machinery_references' => '参考',
		'd2u_machinery_request' => '问询',
		'd2u_machinery_service' => '服務細節',
		'd2u_machinery_software' => '软件',
		'd2u_machinery_tech_data' => '技术数据',
		'd2u_machinery_unit_a' => '安培',
		'd2u_machinery_unit_a_mm' => '(a) 毫米',
		'd2u_machinery_unit_bar' => '巴',
		'd2u_machinery_unit_ca' => '约',
		'd2u_machinery_unit_cm' => '公分',
		'd2u_machinery_unit_cm2' => '平方厘米',
		'd2u_machinery_unit_diameter_mm' => 'Ø 毫米',
		'd2u_machinery_unit_degrees' => '°',
		'd2u_machinery_unit_hz' => '赫兹',
		'd2u_machinery_unit_kg' => '公斤',
		'd2u_machinery_unit_kg_m' => '公斤/计',
		'd2u_machinery_unit_kn' => '千牛顿',
		'd2u_machinery_unit_kw' => '千瓦',
		'd2u_machinery_unit_l' => '升',
		'd2u_machinery_unit_l_min' => '升/最低',
		'd2u_machinery_unit_m' => '计',
		'd2u_machinery_unit_m2_h' => '平方米/小时',
		'd2u_machinery_unit_m_min' => '计/最低',
		'd2u_machinery_unit_min1' => '最低-1',
		'd2u_machinery_unit_mm' => '毫米',
		'd2u_machinery_unit_mm_min' => '毫米/最低',
		'd2u_machinery_unit_pieces' => '块',
		'd2u_machinery_unit_rotations_min' => '转/分钟',
		'd2u_machinery_unit_v' => '伏特',
		'd2u_machinery_usage_areas' => '工艺支持',
		'd2u_machinery_video' => '视频',
		'd2u_machinery_weight' => '重量'
	];
	
	/**
	 * Factory method.
	 * @return d2u_machinery_lang_helper Object
	 */
	public static function factory() {
		return new self();
	}
	
	/**
	 * Installs the replacement table for this addon.
	 */
	public function install() {
		foreach($this->replacements_english as $key => $value) {
			foreach (rex_clang::getAllIds() as $clang_id) {
				$lang_replacement = rex_config::get('d2u_machinery', 'lang_replacement_'. $clang_id, '');

				// Load values for input
				if($lang_replacement === 'chinese' && isset($this->replacements_chinese) && isset($this->replacements_chinese[$key])) {
					$value = $this->replacements_chinese[$key];
				}
				else if($lang_replacement === 'czech' && isset($this->replacements_czech) && isset($this->replacements_czech[$key])) {
					$value = $this->replacements_czech[$key];
				}
				else if($lang_replacement === 'dutch' && isset($this->replacements_dutch) && isset($this->replacements_dutch[$key])) {
					$value = $this->replacements_dutch[$key];
				}
				else if($lang_replacement === 'french' && isset($this->replacements_french) && isset($this->replacements_french[$key])) {
					$value = $this->replacements_french[$key];
				}
				else if($lang_replacement === 'german' && isset($this->replacements_german) && isset($this->replacements_german[$key])) {
					$value = $this->replacements_german[$key];
				}
				else if($lang_replacement === 'italian' && isset($this->replacements_italian) && isset($this->replacements_italian[$key])) {
					$value = $this->replacements_italian[$key];
				}
				else if($lang_replacement === 'polish' && isset($this->replacements_polish) && isset($this->replacements_polish[$key])) {
					$value = $this->replacements_polish[$key];
				}
				else if($lang_replacement === 'portuguese' && isset($this->replacements_portuguese) && isset($this->replacements_portuguese[$key])) {
					$value = $this->replacements_portuguese[$key];
				}
				else if($lang_replacement === 'russian' && isset($this->replacements_russian) && isset($this->replacements_russian[$key])) {
					$value = $this->replacements_russian[$key];
				}
				else if($lang_replacement === 'spanish' && isset($this->replacements_spanish) && isset($this->replacements_spanish[$key])) {
					$value = $this->replacements_spanish[$key];
				}
				else { 
					$value = $this->replacements_english[$key];
				}

				$overwrite = rex_config::get('d2u_machinery', 'lang_wildcard_overwrite', FALSE) === "true" ? TRUE : FALSE;
				parent::saveValue($key, $value, $clang_id, $overwrite);
			}
		}
	}
}